Package org.apache.velocity.runtime.parser

# Class VelocityCharStream

java.lang.Object
org.apache.velocity.runtime.parser.VelocityCharStream

All Implemented Interfaces:
  `CharStream`

public final class VelocityCharStream extends Object implements CharStream

An implementation of interface CharStream, where the stream is assumed to contain only ASCII characters (without unicode processing).

NOTE : This class was originally an ASCII_CharStream autogenerated by Javacc. It was then modified via changing class name with appropriate fixes for CTORS, and mods to readChar().

This is safe because we *always* use Reader with this class, and never a InputStream. This guarantees that we have a correct stream of 16-bit chars - all encoding transformations have been done elsewhere, so we believe that there is no risk in doing this. Time will tell :)

## Field Summary

Fields
Modifier and Type
Field
Description
`int`
`bufpos`
`static final boolean`
`staticFlag`

## Constructor Summary

Constructors
Constructor
Description
`VelocityCharStream(InputStream dstream, int startline, int startcolumn)`
`VelocityCharStream(InputStream dstream, int startline, int startcolumn, int buffersize)`
`VelocityCharStream(Reader dstream, int startline, int startcolumn)`
`VelocityCharStream(Reader dstream, int startline, int startcolumn, int buffersize)`

## Method Summary

Modifier and Type
Method
Description
`void`
`adjustBeginLineColumn(int newLine, int newCol)`
Method to adjust line and column numbers for the start of a token.
`final void`
`backup(int amount)`
Backs up the input stream by amount steps.
`final char`
`BeginToken()`
Returns the next character that marks the beginning of the next token.
`void`
`Done()`
The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class.
`final int`
`getBeginColumn()`
Returns the column number of the first character for current token (being matched after the last call to BeginTOken).
`final int`
`getBeginLine()`
Returns the line number of the first character for current token (being matched after the last call to BeginTOken).
`final int`
`getEndColumn()`
Returns the column number of the last character for current token (being matched after the last call to BeginTOken).
`final int`
`getEndLine()`
Returns the line number of the last character for current token (being matched after the last call to BeginTOken).
`final String`
`GetImage()`
Returns a string made up of characters from the marked token beginning to the current buffer position.
`final char[]`
`GetSuffix(int len)`
Returns an array of characters that make up the suffix of length 'len' for the currently matched token.
`final char`
`readChar()`
Returns the next character from the selected input.
`void`
`ReInit(InputStream dstream, int startline, int startcolumn)`
`void`
`ReInit(InputStream dstream, int startline, int startcolumn, int buffersize)`
`void`
`ReInit(Reader dstream, int startline, int startcolumn)`
`void`
`ReInit(Reader dstream, int startline, int startcolumn, int buffersize)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### staticFlag

public static final boolean staticFlag

See Also:
  - Constant Field Values

### bufpos

public int bufpos

## Constructor Details

### VelocityCharStream

public VelocityCharStream(Reader dstream, int startline, int startcolumn, int buffersize)

Parameters:
  `dstream` -
  `startline` -
  `startcolumn` -
  `buffersize` -

### VelocityCharStream

public VelocityCharStream(Reader dstream, int startline, int startcolumn)

Parameters:
  `dstream` -
  `startline` -
  `startcolumn` -

### VelocityCharStream

public VelocityCharStream(InputStream dstream, int startline, int startcolumn, int buffersize)

Parameters:
  `dstream` -
  `startline` -
  `startcolumn` -
  `buffersize` -

### VelocityCharStream

public VelocityCharStream(InputStream dstream, int startline, int startcolumn)

Parameters:
  `dstream` -
  `startline` -
  `startcolumn` -

## Method Details

### BeginToken

public final char BeginToken() throws IOException
Description copied from interface: `CharStream`
Returns the next character that marks the beginning of the next token. All characters must remain in the buffer between two successive calls to this method to implement backup correctly.

Specified by:
  `BeginToken` in interface `CharStream`
Returns:
  next token start char
Throws:
  `IOException`
See Also:
  - `CharStream.BeginToken()`

### readChar

public final char readChar() throws IOException
Description copied from interface: `CharStream`
Returns the next character from the selected input. The method of selecting the input is the responsibility of the class implementing this interface. Can throw any java.io.IOException.

Specified by:
  `readChar` in interface `CharStream`
Returns:
  read char
Throws:
  `IOException`
See Also:
  - `CharStream.readChar()`

### getEndColumn

public final int getEndColumn()
Description copied from interface: `CharStream`
Returns the column number of the last character for current token (being matched after the last call to BeginTOken).

Specified by:
  `getEndColumn` in interface `CharStream`
Returns:
  ending column number
See Also:
  - `CharStream.getEndColumn()`

### getEndLine

public final int getEndLine()
Description copied from interface: `CharStream`
Returns the line number of the last character for current token (being matched after the last call to BeginTOken).

Specified by:
  `getEndLine` in interface `CharStream`
Returns:
  ending line number
See Also:
  - `CharStream.getEndLine()`

### getBeginColumn

public final int getBeginColumn()
Description copied from interface: `CharStream`
Returns the column number of the first character for current token (being matched after the last call to BeginTOken).

Specified by:
  `getBeginColumn` in interface `CharStream`
Returns:
  starting column number
See Also:
  - `CharStream.getBeginColumn()`

### getBeginLine

public final int getBeginLine()
Description copied from interface: `CharStream`
Returns the line number of the first character for current token (being matched after the last call to BeginTOken).

Specified by:
  `getBeginLine` in interface `CharStream`
Returns:
  starting line number
See Also:
  - `CharStream.getBeginLine()`

### backup

public final void backup(int amount)
Description copied from interface: `CharStream`
Backs up the input stream by amount steps. Lexer calls this method if it had already read some characters, but could not use them to match a (longer) token. So, they will be used again as the prefix of the next token and it is the implemetation's responsibility to do this right.

Specified by:
  `backup` in interface `CharStream`
Parameters:
  `amount` -
See Also:
  - `CharStream.backup(int)`

### ReInit

public void ReInit(Reader dstream, int startline, int startcolumn, int buffersize)

Parameters:
  `dstream` -
  `startline` -
  `startcolumn` -
  `buffersize` -

### ReInit

public void ReInit(Reader dstream, int startline, int startcolumn)

Parameters:
  `dstream` -
  `startline` -
  `startcolumn` -

### ReInit

public void ReInit(InputStream dstream, int startline, int startcolumn, int buffersize)

Parameters:
  `dstream` -
  `startline` -
  `startcolumn` -
  `buffersize` -

### ReInit

public void ReInit(InputStream dstream, int startline, int startcolumn)

Parameters:
  `dstream` -
  `startline` -
  `startcolumn` -

### GetImage

public final String GetImage()
Description copied from interface: `CharStream`
Returns a string made up of characters from the marked token beginning to the current buffer position. Implementations have the choice of returning anything that they want to. For example, for efficiency, one might decide to just return null, which is a valid implementation.

Specified by:
  `GetImage` in interface `CharStream`
Returns:
  token image
See Also:
  - `CharStream.GetImage()`

### GetSuffix

public final char[] GetSuffix(int len)
Description copied from interface: `CharStream`

Returns an array of characters that make up the suffix of length 'len' for the currently matched token. This is used to build up the matched string for use in actions in the case of MORE. A simple and inefficient implementation of this is as follows :

       {
          String t = GetImage();
          return t.substring(t.length() - len, t.length()).toCharArray();
       }

Specified by:
  `GetSuffix` in interface `CharStream`
Parameters:
  `len` - suffix len
Returns:
  suffix
See Also:
  - `CharStream.GetSuffix(int)`

### Done

public void Done()
Description copied from interface: `CharStream`
The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class. Again, the body of this function can be just empty and it will not affect the lexer's operation.

Specified by:
  `Done` in interface `CharStream`
See Also:
  - `CharStream.Done()`

### adjustBeginLineColumn

public void adjustBeginLineColumn(int newLine, int newCol)
Method to adjust line and column numbers for the start of a token.

Parameters:
  `newLine` -
  `newCol` -